package com.ibiz5.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.Param;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import com.ibiz5.sample.domain.IBZ5UNIPRODUCT;
import com.ibiz5.sample.service.dto.IBZ5UNIPRODUCTSearchFilter;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;

public interface IBZ5UNIPRODUCTMapper extends BaseMapper<IBZ5UNIPRODUCT>{

    List<IBZ5UNIPRODUCT> searchIndexDER(@Param("srf") IBZ5UNIPRODUCTSearchFilter searchfilter,@Param("ew") Wrapper<IBZ5UNIPRODUCT> wrapper) ;
    Page<IBZ5UNIPRODUCT> searchIndexDER(IPage page, @Param("srf") IBZ5UNIPRODUCTSearchFilter searchfilter, @Param("ew") Wrapper<IBZ5UNIPRODUCT> wrapper) ;
    List<IBZ5UNIPRODUCT> searchDefault(@Param("srf") IBZ5UNIPRODUCTSearchFilter searchfilter,@Param("ew") Wrapper<IBZ5UNIPRODUCT> wrapper) ;
    Page<IBZ5UNIPRODUCT> searchDefault(IPage page, @Param("srf") IBZ5UNIPRODUCTSearchFilter searchfilter, @Param("ew") Wrapper<IBZ5UNIPRODUCT> wrapper) ;
    @Select("${sql}")
    List<Map<String,Object>> selectRow( @Param("sql")String sql);
    @Override
    @Cacheable( value="entity",key = "'IBZ5UNIPRODUCT:'+#p0")
    IBZ5UNIPRODUCT selectById(Serializable id);
    @Override
    @CacheEvict( value="entity",key = "'IBZ5UNIPRODUCT:'+#p0.ibz5uniproductid")
    int insert(IBZ5UNIPRODUCT entity);
    @Override
    @CacheEvict( value="entity",key = "'IBZ5UNIPRODUCT:'+#p0.ibz5uniproductid")
    int updateById(@Param(Constants.ENTITY) IBZ5UNIPRODUCT entity);
    @Override
    @CacheEvict( value="entity",key = "'IBZ5UNIPRODUCT:'+#p0")
    int deleteById(Serializable id);
    Page<IBZ5UNIPRODUCT> selectPermission(IPage page,@Param("pw") Wrapper<IBZ5UNIPRODUCT> wrapper) ;
}