package com.ibiz5.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.Param;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import com.ibiz5.sample.domain.IBZ5CUSTOMERMG;
import com.ibiz5.sample.service.dto.IBZ5CUSTOMERMGSearchFilter;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;

public interface IBZ5CUSTOMERMGMapper extends BaseMapper<IBZ5CUSTOMERMG>{

    List<IBZ5CUSTOMERMG> searchDefault(@Param("srf") IBZ5CUSTOMERMGSearchFilter searchfilter,@Param("ew") Wrapper<IBZ5CUSTOMERMG> wrapper) ;
    Page<IBZ5CUSTOMERMG> searchDefault(IPage page, @Param("srf") IBZ5CUSTOMERMGSearchFilter searchfilter, @Param("ew") Wrapper<IBZ5CUSTOMERMG> wrapper) ;
    @Select("${sql}")
    List<Map<String,Object>> selectRow( @Param("sql")String sql);
    @Override
    @Cacheable( value="entity",key = "'IBZ5CUSTOMERMG:'+#p0")
    IBZ5CUSTOMERMG selectById(Serializable id);
    @Override
    @CacheEvict( value="entity",key = "'IBZ5CUSTOMERMG:'+#p0.ibz5customerid")
    int insert(IBZ5CUSTOMERMG entity);
    @Override
    @CacheEvict( value="entity",key = "'IBZ5CUSTOMERMG:'+#p0.ibz5customerid")
    int updateById(@Param(Constants.ENTITY) IBZ5CUSTOMERMG entity);
    @Override
    @CacheEvict( value="entity",key = "'IBZ5CUSTOMERMG:'+#p0")
    int deleteById(Serializable id);
    Page<IBZ5CUSTOMERMG> selectPermission(IPage page,@Param("pw") Wrapper<IBZ5CUSTOMERMG> wrapper) ;
}