package com.ibiz5.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.Param;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import com.ibiz5.sample.domain.IBZ5ORDERDETAIL;
import com.ibiz5.sample.service.dto.IBZ5ORDERDETAILSearchFilter;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;

public interface IBZ5ORDERDETAILMapper extends BaseMapper<IBZ5ORDERDETAIL>{

    List<IBZ5ORDERDETAIL> searchDefault(@Param("srf") IBZ5ORDERDETAILSearchFilter searchfilter,@Param("ew") Wrapper<IBZ5ORDERDETAIL> wrapper) ;
    Page<IBZ5ORDERDETAIL> searchDefault(IPage page, @Param("srf") IBZ5ORDERDETAILSearchFilter searchfilter, @Param("ew") Wrapper<IBZ5ORDERDETAIL> wrapper) ;
    @Select("${sql}")
    List<Map<String,Object>> selectRow( @Param("sql")String sql);
    @Override
    @Cacheable( value="entity",key = "'IBZ5ORDERDETAIL:'+#p0")
    IBZ5ORDERDETAIL selectById(Serializable id);
    @Override
    @CacheEvict( value="entity",key = "'IBZ5ORDERDETAIL:'+#p0.ibz5orderdetailid")
    int insert(IBZ5ORDERDETAIL entity);
    @Override
    @CacheEvict( value="entity",key = "'IBZ5ORDERDETAIL:'+#p0.ibz5orderdetailid")
    int updateById(@Param(Constants.ENTITY) IBZ5ORDERDETAIL entity);
    @Override
    @CacheEvict( value="entity",key = "'IBZ5ORDERDETAIL:'+#p0")
    int deleteById(Serializable id);
    Page<IBZ5ORDERDETAIL> selectPermission(IPage page,@Param("pw") Wrapper<IBZ5ORDERDETAIL> wrapper) ;
}