package com.ibiz5.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.Param;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import com.ibiz5.sample.domain.INT_PROUDCT;
import com.ibiz5.sample.service.dto.INT_PROUDCTSearchFilter;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;

public interface INT_PROUDCTMapper extends BaseMapper<INT_PROUDCT>{

    List<INT_PROUDCT> searchDefault(@Param("srf") INT_PROUDCTSearchFilter searchfilter,@Param("ew") Wrapper<INT_PROUDCT> wrapper) ;
    Page<INT_PROUDCT> searchDefault(IPage page, @Param("srf") INT_PROUDCTSearchFilter searchfilter, @Param("ew") Wrapper<INT_PROUDCT> wrapper) ;
    @Select("${sql}")
    List<Map<String,Object>> selectRow( @Param("sql")String sql);
    @Override
    @Cacheable( value="entity",key = "'INT_PROUDCT:'+#p0")
    INT_PROUDCT selectById(Serializable id);
    @Override
    @CacheEvict( value="entity",key = "'INT_PROUDCT:'+#p0.int_proudctid")
    int insert(INT_PROUDCT entity);
    @Override
    @CacheEvict( value="entity",key = "'INT_PROUDCT:'+#p0.int_proudctid")
    int updateById(@Param(Constants.ENTITY) INT_PROUDCT entity);
    @Override
    @CacheEvict( value="entity",key = "'INT_PROUDCT:'+#p0")
    int deleteById(Serializable id);
    Page<INT_PROUDCT> selectPermission(IPage page,@Param("pw") Wrapper<INT_PROUDCT> wrapper) ;
}